#ifndef __SIMPLE_SEMANTICS_SYMBOL_H__
#define __SIMPLE_SEMANTICS_SYMBOL_H__

#include <string>
#include <cdk/basic_type.h>

namespace simple {

  class symbol {
    basic_type *_type;
    std::string _name;
    long _value; // hack!

  public:
    symbol(basic_type *type, const std::string &name, long value) :
        _type(type), _name(name), _value(value) {
    }

    virtual ~symbol() {
      delete _type;
    }

    basic_type *type() const {
      return _type;
    }
    const std::string &name() const {
      return _name;
    }
    long value() const {
      return _value;
    }
    long value(long v) {
      return _value = v;
    }
  };

} // simple

#endif
